% Example 9.13

% Priors are 0.5 for both classes.
% Generate 200 data points for testing.
% Find the number in each class.
n = 200;
u = rand(1,n);
% Find the number in class 1.
n1 = length(find(u<=0.5));
n2 = n - n1;
% Generate the ones for class 1
% Half are upper right corner, half are lower left
data1 = zeros(n1,2);
u = rand(1,n1);
n11 = length(find(u<=0.5));
n12 = n1 - n11;
data1(1:n11,:)=rand(n11,2)+.5;  
data1(n11+1:n1,:) = rand(n12,2)-.5;

% Generate the ones for class 2.
% Half are in lower right corner, half are upper left
data2 = rand(n2,2);
u = rand(1,n2);
n21 = length(find(u<=0.5));
n22 = n2 - n21;
data2(1:n21,1)=rand(n21,1)-.5;  
data2(1:n21,2)=rand(n21,1)+.5;
data2(n21+1:n2,1)=rand(n22,1)+.5;												
data2(n21+1:n2,2)=rand(n22,1)-.5;

% Now check the trees using independent test 
% cases in data1 and data2.
% Keep track of the ones missclassified.
K = length(treeseq);
Rk = zeros(1,K-1); % we do not check the root
for k = 1:K-1
		nmis = 0;
		treek = treeseq{k};
		% loop through the cases from class 1
		for i = 1:n1					
				[clas,pclass,node]=cstreec(data1(i,:),treek);
				if clas ~= 1 
					nmis = nmis+1;					% misclassified
				end
		end
		% Loop through class 2 cases
		for i = 1:n2
			[clas,pclass,node]=cstreec(data2(i,:),treek);
			if clas ~= 2
				nmis = nmis+1;			 % misclassified
			end
		end
   		Rk(k) = nmis/n;
end

% Find the minimum Rk.
[mrk,ind]=min(Rk);
% The tree T_1 corresponds to the minimum Rk.
% Now find the se for that one.
semrk = sqrt(mrk*(1-mrk)/n);
% The SE is 0.0070. We add that to min(Rk).
Rk2 = mrk+semrk;

