% Example  9.14
% This contains the complete steps for
% classification trees - cross-validation

% We will use the iris data - partition into 5 groups
% We will not randomly sample into groups, but will
% keep the class fraction the same.

% Class 1: iris setosa
% Class 2: iris versicolor
% Class 3: iris virginica

load iris
% Attach class labels.
setosa(:,5)=1;
versicolor(:,5)=2;
virginica(:,5)=3;
X = [setosa;versicolor;virginica];
n = 150;	% total number of data points
% These indices indicate the partitions.
ind1 = 1:5:50;
ind2 = 2:5:50;
ind3 = 3:5:50;
ind4 = 4:5:50;
ind5 = 5:5:50;
% Get the testing sets: test1, test2, ...
for i = 1:5
	eval(['test' int2str(i) '=[setosa(ind' int2str(i) ',:);versicolor(ind' int2str(i) ...
			',:);virginica(ind' int2str(i) ',:)];'])
end
for i = 1:5
	tmp1 = setosa;
	tmp2 = versicolor;
	tmp3 = virginica;
	% Remove the points that are in the test set.
	eval(['tmp1(ind' int2str(i) ',:) = [];'])
	eval(['tmp2(ind' int2str(i) ',:) = [];'])
	eval(['tmp3(ind' int2str(i) ',:) = [];'])
	eval(['train' int2str(i) '= [tmp1;tmp2;tmp3];'])
end
% Grow all of the trees.
pies = ones(1,3)/3;
maxn = 2;	% get large trees
clas = 1:3;
Nk = [50,50,50];
tree = csgrowc(X,maxn,clas,Nk,pies);
Nk1 = [40 40 40];
for i = 1:5
	eval(['tree' int2str(i) '= csgrowc(train' int2str(i) ',maxn,clas,Nk1,pies);'])
end
% Now prune each sequence.
treeseq = csprunec(tree);
for i = 1:5
	eval(['treeseq' int2str(i) '= csprunec(tree' int2str(i) ');'])
end

K=length(treeseq);
alpha = zeros(1,K);
% Find the sequence of alphas.
for i = 1:K
	alpha(i) = treeseq{i}.alpha;
end
K1 = length(treeseq1);
for i = 1:K1
	alpha1(i) = treeseq1{i}.alpha;
end
K2 = length(treeseq2);
for i = 1:K2
	alpha2(i) = treeseq2{i}.alpha;
end
K3 = length(treeseq3);
for i = 1:K3
	alpha3(i) = treeseq3{i}.alpha;
end
K4 = length(treeseq4);
for i = 1:K4
	alpha4(i) = treeseq4{i}.alpha;
end
K5 = length(treeseq5);
for i = 1:K5
	alpha5(i) = treeseq5{i}.alpha;
end
% Get the akprime equivalent values for the main tree.
for i = 1:K-1
	akprime(i) = sqrt(alpha(i)*alpha(i+1));
end

% Now find the error for each tree according to the value of ak'  
n=150;
k = length(akprime);
Rk = zeros(1,k);
seRk = zeros(1,k);
for i = 1:k
	misclass = zeros(1,n);
	% Find the tree from the first partition.
	ind = find(alpha1 <= akprime(i)); 
	% Get the tree that corresponds to that one.
	tk = treeseq1{ind(end)};
	% Get the misclassified points in the test set.
	for j = 1:30  	% loop through the points in test 1
		[c,pclass,node]=cstreec(test1(j,1:4),tk);
		if c ~= test1(j,5)
			misclass(j) = 1;
		end
	end
	% Gind the tree from the second partition.
	ind = find(alpha2<=akprime(i)); 
	% Get the tree that corresponds to that one.
	tk = treeseq2{ind(end)};
	% Get the misclassified points in the test set.
	for j = 1:30  	% loop through the points in test 1
		[c,pclass,node]=cstreec(test2(j,1:4),tk);
		if c ~= test2(j,5)
			misclass(j+30) = 1;
		end
	end
		% Find the tree from the third partition.
	ind = find(alpha3 <= akprime(i)); 
	% Get the tree that corresponds to that one.
	tk = treeseq3{ind(end)};
	% Get the misclassified points in the test set.
	for j = 1:30  	% loop through the points in test 1
		[c,pclass,node]=cstreec(test3(j,1:4),tk);
		if c ~= test3(j,5)
			misclass(j+60) = 1;
		end
	end
		% find the tree from the fourth partition
	ind = find(alpha4 <= akprime(i)); 
	% Get the tree that corresponds to that one.
	tk = treeseq4{ind(end)};
	% get the misclassified points in the test set
	for j = 1:30  	% loop through the points in test 1
		[c,pclass,node]=cstreec(test4(j,1:4),tk);
		if c ~= test4(j,5)
			misclass(j+90) = 1;
		end
	end
		% find the tree from the fifth partition
	ind = find(alpha5 <= akprime(i)); 
	% Get the tree that corresponds to that one.
	tk = treeseq5{ind(end)};
	% get the misclassified points in the test set
	for j = 1:30  	% loop through the points in test 1
		[c,pclass,node]=cstreec(test5(j,1:4),tk);
		if c ~= test5(j,5)
			misclass(j+120) = 1;
		end
	end
	Rk(i) = mean(misclass);
	seRk(i) = ((n-1)/n)*var(misclass);
end

% Get the standard deviation for the smallest value.
sehat = sqrt(seRk/n);
[Rkmin,mi] = min(Rk);
tol = Rkmin+sehat(mi);
	
%tol =    0.0639

% Rk =    0.0467    0.0467    0.0467    0.0667    0.2133    0.4067

% WE WOULD PICK THE TREE CORRESPONDING TO K=3, SINCE THAT HAS THE
% LEAST COMPLEXITY WITHIN THE TOLERANCE.
	
	
	
